var current_svg = 0;
var current_chart = 0;
var current_datas = 0;
var current_layout = 0;
var conf = parseQueryString(window.location.href.split("?")[1]);

var x;
var y;

var valueoffset = (new Date().getTimezoneOffset()) * 60;
var newhd = H1({'id':'hd2'}, "Mémos de la voie " + conf['chan']);


function xMyScale (value) {
	
	var d = new Date((value + valueoffset) * 1000 );
	var f = numberFormatter("00");
	value = f(d.getDate()) + '/' + f(d.getMonth() + 1) +' '+ f(d.getHours());
	value += ':' + f(d.getMinutes());
	return value;
} 

function modifXaxis( tick ) {
	tick[1] = xMyScale(tick[1]);
} 

function yMyScale (value) {
	var f; 
	if (conf['a'] != 0) {
		f = (conf['a'] * value) + conf['b'];
		f = Math.round( f * 100) / 100;

		if (compare(conf['unite'], null) != 0) {
			f = f.toString() + ' ' + conf['unite'];
		} 

	} else { //tor
		if (compare(conf['unite'], null) == 0) {
			conf['unite'] = 0;
		}

		if (compare(conf['active'], null) == 0) {
			conf['active'] = 1;
		}



		if (value == 1) {
			f = conf['active'];
		} else if (value == 0) {
			f = conf['unite'];
		} else {
			f = '';
		}
	}



	return f;
}

function modifYAxis ( tick ) {
	tick[1] = yMyScale(tick[1]);
}

function loadDM()
{
	if ($('val_num').value != '') {
	var d = loadJSONDoc('/cgidm', {'chan': conf['chan'], 'val_num' : $('val_num').value});
	} else {
	var d = loadJSONDoc('/cgidm', {'chan': conf['chan']});
	}

	var on_load = function(meta) {
		conf['unite'] = meta['unite'];
		conf['active'] = meta['active'];
		conf['a'] = parseFloat(meta['a']);
		conf['b'] = parseFloat(meta['b']);

		var newhd = H1({'id':'hd2'}, "Mémos de la voie " + conf['chan'] + " : " + meta['name']);
		swapDOM($('hd2'), newhd);
		var newvalue = SPAN({'id':'value'}, meta['current']);
		swapDOM('value', newvalue);
	
		var layout_opts = {
		 "xOriginIsZero": false,
		 "yOriginIsZero": false,
		 'xNumberOfTicks': 5,
		 "xTicksDisplay": modifXaxis,
		 "yTicksDisplay": modifYAxis
		};

		var layout = new Layout("line", layout_opts);

		
		if (meta['type'] == 'ETOR' || meta['type'] == 'STOR') {
			var source_data = meta['data']
			var dest_data = [];
			var j = 0;
			var ts = 0; //time stamp
			var val = 0; //value
			//on reconstruit les point intermediaires
			dest_data[j] = tmp = source_data [0];

			for (i = 1; i < source_data.length; i++) {
				j++;
				if (source_data[i][1] != tmp[1]) {
					dest_data[j] = [source_data[i][0] - 0.1, tmp[1]];
					tmp = source_data[i];
					j++;
				} 

				dest_data[j] = source_data[i];

			}
			layout.addDataset("Memo " , dest_data);
			meta['data'] = dest_data;
		} else {	
			layout.addDataset("Memo " , meta['data']);
		}
		

		layout.evaluate();
	
		
		var svg_opts = {
		"width": 700,
		"height": 300,
		"id":"chart"
		}

		var svg = SVGRenderer.SVG(svg_opts);
		if (current_svg == 0 && current_chart == 0) {

		} else {		
			current_chart.clear();
			$('svgcontainer').removeChild(current_svg);
		}

		$('svgcontainer').appendChild(svg);

		setNodeAttribute($('svgcontainer'),'border','0px' );

		if ($('loaddiv')) {
			removeElement('loaddiv');
		}

		var chart_opts = {
			"shouldFill" : false,
			"strokeColor" : Color.redColor(),
			"strokeWidth": 0.1,
			"drawBackground": false,
			"axisLabelColor": Color.blackColor(),
			"padding": {left: 60, right: 30, top: 5, bottom: 20}
		}
		var chart = new SVGRenderer(svg, layout, chart_opts);

		current_svg = svg;
		current_chart = chart;
		current_datas = meta['data'];
		current_layout = layout;

		chart.render();

		var atts_circle  = {
		//	'id' : '',
			'stroke' : "rgb(0,0,255)", 
			'strokeWidth': "0.3",
			'r': '2px',
			'fill': 'none'
		}

		var points = current_layout.points;	
		for (var i in points) {
			j = points[i];
			var x = j.x * current_chart.area.w + current_chart.area.x;
			var y = j.y * current_chart.area.h + current_chart.area.y;
			atts_circle['cx'] = x + 'px';
			atts_circle['cy'] = y  + 'px';

			var lp = current_chart.createSVGElement("circle", atts_circle);
			current_chart.root.appendChild(lp);
		}

		if (conf['refresh'])
			callLater(5, loadDM);
	}

	var on_error = function(err) {
		alert("Error getting data : err");
	}

	d.addCallbacks(on_load, on_error);

};

var wasMoved = function(e) {
	var coord = e.mouse().page;
	var offset = elementPosition($('svgcontainer'));

	if (current_chart == 0 || current_datas == 0) {
		return;
	}

	coord.x = coord.x - offset.x;
	coord.y = coord.y - offset.y;

	var atts = {
	'id': 'cursor_line', 
	'stroke' : "rgb(128,128,128)", 
	'strokeWidth': "0.5"
	}

	var atts_2  = {
	'id' : 'cursor_line2',
	'stroke' : "rgb(0,255,0)", 
	'strokeWidth': "0.5",
	'r': '8px'
	}

	var atts_circle  = {
	'id' : 'cursor_circle',
	'stroke' : "rgb(0,255,0)", 
	'strokeWidth': "0.5",
	'r': '8px',
	'fill': 'none'
	}
	
	var memos = current_datas;

	if ( coord.x > current_chart.area.x && coord.x < current_chart.area.x + current_chart.area.w) {
		var position =(coord.x - current_chart.area.x) / current_chart.area.w;
		var index = Math.round(position * memos.length);

		if (index >= memos.length) 
			index = memos.length - 1;
		
		var scale = current_layout.yscale;
		var minval =  current_layout.minyval;
		var cy = current_layout.yscale * (memos[index][1] - current_layout.minyval);
		cy = 1.0 - cy;
		cy = cy * current_chart.area.h;
		
		node  = $('cursor_line');

		if (node) {
			setNodeAttribute( node,'x1', coord.x + 'px');
			setNodeAttribute( node,'x2', coord.x + 'px');
			var cir = $('cursor_circle');
			setNodeAttribute( cir, 'cx', coord.x + 'px');
			setNodeAttribute( cir, 'cy', cy + 'px');
			

	//		setNodeAttribute( node2,'y1', cy + 'px');
	//		setNodeAttribute( node2,'y2', cy + 'px');
		} else {
			current_chart._drawLine(coord.x, current_chart.area.y ,coord.x, current_chart.area.y + current_chart.area.h , atts);
			//current_chart._drawLine( current_chart.area.x, cy ,current_chart.area.x + current_chart.area.w, cy, atts_2);
	
		atts_circle['cx'] = coord.x + 'px';
			atts_circle['cy'] = cy + 'px';
			var circle = current_chart.createSVGElement("circle", atts_circle);
			current_chart.root.appendChild(circle);
			
		}

		var my_div = SPAN({'id':'pos_cursor'}, xMyScale(memos[index][0]) + " : " + yMyScale(memos[index][1]));
		swapDOM('pos_cursor', my_div);

	}

}
			


window.onload = function()
{
	loadDM();
	swapDOM('hd', newhd);
	connect('svgcontainer', 'onmousemove', wasMoved);

};

