require('json')
require('send')
require('web.auth')

function station_init(chan) 
	s = global_session

	if dm == nil then
		dm = perax:open_dm()
	end

	local t = dm:info(parameters.chan)
	local n = tonumber(parameters.chan)

	if n > 0 then
		local i = mem:info_chan(n) 
		t.name = i.name
	end

	-- filtering modification
	if s and parameters.filter ~= nil and parameters.filter ~= '' then
		dm:read(parameters.chan)
		s['filtered_station'] = {}
		total_filtered = 0
		for i = 1, t.valid_lines do
			line = dm:getn(mem, i)
			if line and line['name']:find(parameters.filter) then
				total_filtered = total_filtered + 1
				s['filtered_station'][total_filtered] = i
			end
		end
		t.valid_lines = total_filtered

	else 
		if s then
			s['filtered_station'] = nil
		end
	end
	-- endof filtering

	out(json_table(t, 1))
	--out (json_table(parameters, 1))
end

function station_index(chan)
	s = global_session
	if parameters.chan == nil then
		parameters.chan = -1
	end
	
	if not s['filtered_station'] then
		dm:read(parameters.chan)
	end

	out('{ "datas": ')
	out('[')

	if parameters.items ~= nil then
		string.gsub(parameters.items,'([0-9]+)', function (j)
			local t = {}
			if s and s['filter_station'] then
				t = dm:getn(mem, s['filter_station'][j])
			else
				t = dm:getn(mem, j)
			end
			if t ~= nil then 
				json_table(t, 1)
				out(', ')
			end
		end)
	end
	out (']')

	if tonumber(parameters.chan) >= 1 then 
		out(', "infos" : ')
		send_one_chan(parameters.chan)
	end

	out ('}');
	
end

function station_index_old(chan)
	t = dm:info(parameters.chan)
	mt = {}
	ft = {}
	i = 1
	k = 1
	if parameters.items ~= nil and t ~= nil then
		string.gsub(parameters.items,'([0-9]+)', function (j)
			j = tonumber(j) 
			if j < t.valid_lines and j >= 0 then
				j = t.current_position - j
				if j < 1 then 
					j = t.valid_lines - j
				end

				if (i > 1 and j > mt[i-1]) or k ~= 1 then
					ft[k] = j
					k = k + 1
				else 

					mt[i] = j
					i = i + 1
				end
			end
		end)

-- testing part
--		out('[')
--		if #mt > 0 then
--			json_table(mt, 1)
--		end

--		if #ft > 0 then 
--			out (',')
--			json_table(ft, 1)
--		end
--		out(']')

	else
		out('{}')
	end
end

function station_raz () 
	s = global_session

	if s == nil then
		out('{return : 0, message : "Vous n\'etes pas loggue."}');
		return
	end

	if s.user.diag == nil then
		out('{return : 0, message : "Vous n\'avez pas les droits en ecriture."}');
		return
	end


	if parameters.t ~= nil then
		t = parameters.t
		if parameters.n ~= nil then
			n = parameters.n
			dm:raz(t, n, tonumber(s.user.id))
		end
	end
	out ('{return: 1}')
end
